(!stylesheet "t-y-scheme-Z-S.css")
(!html-head "<meta name=description content=\"A practical\nintroduction to the programming language Scheme\">\n\n<meta name=author content=\"Dorai Sitaram\">\n\n<link rev=made href=\"mailto:ds26@gte.com\">\n")
(!default-title "Teach Yourself Scheme in Fixnum Days")
(!toc-page 1)
(!using-chapters)
(!toc-entry 0 "IGNORE" 2 "%_chap_Temp_1" "{Preface}")
(!using-chapters)
(!toc-entry 0 "1" 3 "%_chap_1" "{Enter Scheme}")
(!using-chapters)
(!toc-entry 0 "2" 4 "%_chap_2" "{Data types}")
(!toc-entry 1 "2.1" 4 "%_sec_2.1" "{Simple data types}")
(!toc-entry 2 "2.1.1" 4 "%_sec_2.1.1" "{Booleans}")
(!toc-entry 2 "2.1.2" 4 "%_sec_2.1.2" "{Numbers}")
(!toc-entry 2 "2.1.3" 4 "%_sec_2.1.3" "{Characters}")
(!toc-entry 2 "2.1.4" 4 "%_sec_2.1.4" "{Symbols}")
(!toc-entry 1 "2.2" 4 "%_sec_2.2" "{Compound data types}")
(!toc-entry 2 "2.2.1" 4 "%_sec_2.2.1" "{Strings}")
(!toc-entry 2 "2.2.2" 4 "%_sec_2.2.2" "{Vectors}")
(!toc-entry 2 "2.2.3" 4 "%_sec_2.2.3" "{Dotted pairs and lists}")
(!toc-entry 2 "2.2.4" 4 "%_sec_2.2.4" "{Conversions between data types}")
(!toc-entry 1 "2.3" 4 "%_sec_2.3" "{Other data types}")
(!toc-entry 1 "2.4" 4 "%_sec_2.4" "{S-expressions}")
(!using-chapters)
(!toc-entry 0 "3" 5 "%_chap_3" "{Forms}")
(!toc-entry 1 "3.1" 5 "%_sec_3.1" "{Procedures}")
(!toc-entry 2 "3.1.1" 5 "%_sec_3.1.1" "{Procedure parameters}")
(!toc-entry 2 "3.1.2" 5 "%_sec_3.1.2" "{Variable number of arguments}")
(!toc-entry 1 "3.2" 5 "%_sec_3.2" "{\\q{apply}}")
(!toc-entry 1 "3.3" 5 "%_sec_3.3" "{Sequencing}")
(!using-chapters)
(!toc-entry 0 "4" 6 "%_chap_4" "{Conditionals}")
(!toc-entry 1 "4.1" 6 "%_sec_4.1" "{\\q{when} and \\q{unless}}")
(!toc-entry 1 "4.2" 6 "%_sec_4.2" "{\\q{cond}}")
(!toc-entry 1 "4.3" 6 "%_sec_4.3" "{\\q{case}}")
(!toc-entry 1 "4.4" 6 "%_sec_4.4" "{\\q{and} and \\q{or}}")
(!using-chapters)
(!toc-entry 0 "5" 7 "%_chap_5" "{Lexical variables}")
(!toc-entry 1 "5.1" 7 "%_sec_5.1" "{\\q{let} and \\q{let*}}")
(!toc-entry 1 "5.2" 7 "%_sec_5.2" "{\\q{fluid-let}}")
(!using-chapters)
(!toc-entry 0 "6" 8 "%_chap_6" "{Recursion}")
(!toc-entry 1 "6.1" 8 "%_sec_6.1" "{\\q{letrec}}")
(!toc-entry 1 "6.2" 8 "%_sec_6.2" "{Named \\q{let}}")
(!toc-entry 1 "6.3" 8 "%_sec_6.3" "{Iteration}")
(!toc-entry 1 "6.4" 8 "%_sec_6.4" "{Mapping a procedure across a list}")
(!using-chapters)
(!toc-entry 0 "7" 9 "%_chap_7" "{I/O}")
(!toc-entry 1 "7.1" 9 "%_sec_7.1" "{Reading}")
(!toc-entry 1 "7.2" 9 "%_sec_7.2" "{Writing}")
(!toc-entry 1 "7.3" 9 "%_sec_7.3" "{File ports}")
(!toc-entry 2 "7.3.1" 9 "%_sec_7.3.1" "{Automatic opening and closing of file ports}")
(!toc-entry 1 "7.4" 9 "%_sec_7.4" "{String ports}")
(!toc-entry 1 "7.5" 9 "%_sec_7.5" "{Loading files}")
(!using-chapters)
(!toc-entry 0 "8" 10 "%_chap_8" "{Macros}")
(!toc-entry 1 "8.1" 10 "%_sec_8.1" "{Specifying the expansion as a template}")
(!toc-entry 1 "8.2" 10 "%_sec_8.2" "{Avoiding variable capture inside macros}")
(!toc-entry 1 "8.3" 10 "%_sec_8.3" "{\\q{fluid-let}}")
(!using-chapters)
(!toc-entry 0 "9" 11 "%_chap_9" "{Structures}")
(!toc-entry 1 "9.1" 11 "%_sec_9.1" "{Default initializations}")
(!toc-entry 1 "9.2" 11 "%_sec_9.2" "{\\q{defstruct} defined}")
(!using-chapters)
(!toc-entry 0 "10" 12 "%_chap_10" "{Alists and tables}")
(!using-chapters)
(!toc-entry 0 "11" 13 "%_chap_11" "{System interface}")
(!toc-entry 1 "11.1" 13 "%_sec_11.1" "{Checking for and deleting files}")
(!toc-entry 1 "11.2" 13 "%_sec_11.2" "{Calling operating-system commands}")
(!toc-entry 1 "11.3" 13 "%_sec_11.3" "{Environment variables}")
(!using-chapters)
(!toc-entry 0 "12" 14 "%_chap_12" "{Objects and classes}")
(!toc-entry 1 "12.1" 14 "%_sec_12.1" "{A simple object system}")
(!toc-entry 1 "12.2" 14 "%_sec_12.2" "{Classes are instances too}")
(!toc-entry 1 "12.3" 14 "%_sec_12.3" "{Multiple inheritance}")
(!using-chapters)
(!toc-entry 0 "13" 15 "%_chap_13" "{Jumps}")
(!toc-entry 1 "13.1" 15 "%_sec_13.1" "{\\q{call-with-current-continuation}}")
(!toc-entry 1 "13.2" 15 "%_sec_13.2" "{Escaping continuations}")
(!toc-entry 1 "13.3" 15 "%_sec_13.3" "{Tree matching}")
(!toc-entry 1 "13.4" 15 "%_sec_13.4" "{Coroutines}")
(!toc-entry 2 "13.4.1" 15 "%_sec_13.4.1" "{Tree-matching with coroutines}")
(!using-chapters)
(!toc-entry 0 "14" 16 "%_chap_14" "{Nondeterminism}")
(!toc-entry 1 "14.1" 16 "%_sec_14.1" "{Description of \\q{amb}}")
(!toc-entry 1 "14.2" 16 "%_sec_14.2" "{Implementing \\q{amb} in Scheme}")
(!toc-entry 1 "14.3" 16 "%_sec_14.3" "{Using \\q{amb} in Scheme}")
(!toc-entry 1 "14.4" 16 "%_sec_14.4" "{Logic puzzles}")
(!toc-entry 2 "14.4.1" 16 "%_sec_14.4.1" "{The Kalotan puzzle}")
(!toc-entry 2 "14.4.2" 16 "%_sec_14.4.2" "{Map coloring}")
(!using-chapters)
(!toc-entry 0 "15" 17 "%_chap_15" "{Engines}")
(!toc-entry 1 "15.1" 17 "%_sec_15.1" "{The clock}")
(!toc-entry 1 "15.2" 17 "%_sec_15.2" "{Flat engines}")
(!toc-entry 1 "15.3" 17 "%_sec_15.3" "{Nestable engines}")
(!using-chapters)
(!toc-entry 0 "16" 18 "%_chap_16" "{Shell scripts}")
(!toc-entry 1 "16.1" 18 "%_sec_16.1" "{Hello, World!, again}")
(!toc-entry 1 "16.2" 18 "%_sec_16.2" "{Scripts with arguments}")
(!toc-entry 1 "16.3" 18 "%_sec_16.3" "{Example}")
(!using-chapters)
(!toc-entry 0 "17" 19 "%_chap_17" "{CGI scripts}")
(!toc-entry 1 "17.1" 19 "%_sec_17.1" "{Example: Displaying environment variables}")
(!toc-entry 1 "17.2" 19 "%_sec_17.2" "{Example: Displaying selected environment variable}")
(!toc-entry 1 "17.3" 19 "%_sec_17.3" "{CGI script utilities}")
(!toc-entry 1 "17.4" 19 "%_sec_17.4" "{A calculator via CGI}")
(!using-chapters)
(!toc-entry 0 "A" 20 "%_chap_A" "{Scheme dialects}")
(!toc-entry 1 "A.1" 20 "%_sec_A.1" "{Invocation}")
(!toc-entry 1 "A.2" 20 "%_sec_A.2" "{Init files}")
(!toc-entry 1 "A.3" 20 "%_sec_A.3" "{Shell scripts}")
(!toc-entry 1 "A.4" 20 "%_sec_A.4" "{\\q{define-macro}}")
(!toc-entry 1 "A.5" 20 "%_sec_A.5" "{\\q{load-relative}}")
(!using-chapters)
(!toc-entry 0 "B" 21 "%_chap_B" "{DOS batch files in Scheme}")
(!using-chapters)
(!toc-entry 0 "C" 22 "%_chap_C" "{Numerical techniques}")
(!toc-entry 1 "C.1" 22 "%_sec_C.1" "{Simpson's rule}")
(!toc-entry 1 "C.2" 22 "%_sec_C.2" "{Adaptive interval sizes}")
(!toc-entry 1 "C.3" 22 "%_sec_C.3" "{Improper integrals}")
(!using-chapters)
(!toc-entry 0 "D" 23 "%_chap_D" "{A clock for infinity}")
(!using-chapters)
(!toc-entry 0 "E" 24 "%_chap_E" "{References}")
(!using-external-program "bibtex")
(!using-chapters)
(!toc-entry 0 "F" 25 "%_chap_F" "{Index}")
(!index-page 25)
(!using-external-program "makeindex")
(!last-page-number 25)
(!last-modification-time 1015271650)
